clear all;
close all;

fd=fopen ('robase.log','r');
fread (fd,16,'char');
ScanSize=fread(fd,1,'uint16')
fread (fd,74,'char');
ID=fread(fd,1,'uint32');
Pose=[];
subplot (1,2,1);
ScanG=plot (0,0,'.');
axis square equal;
axis ([-4000 4000 -4000 4000]);
subplot (1,2,2);
OdomG=plot (0,0);

OdomError=0;

Angle=(([44:725]-384)*2*pi)/1024;
%pause;
while (~feof(fd))

    DeltaT=fread(fd,1,'uint32');
    Odom(1)=fread(fd,1,'uint32=>double');       
    Odom(2)=fread(fd,1,'uint32=>double');
    Odom(3)=fread(fd,1,'float=>double');
    if (Odom(1)~=0)
        Pose=[Pose;Odom];
        subplot (1,2,2);
        set (OdomG,'XData',Pose(:,1),'YData',Pose(:,2));
    else
        OdomError=OdomError+1;
        disp (sprintf ('ID = %d Error Odometry #%d',ID,OdomError));
    end
    Scan=fread(fd,ScanSize,'uint16');

    subplot (1,2,1);
    X=Scan'.*cos(Angle);
    Y=Scan'.*sin(Angle);
    set(ScanG,'XData',Y,'YData',X);

   
    drawnow;
%    pause(0.01);
%    pause;


    ID=fread(fd,1,'uint32');
end
fclose (fd);

figure
plot (Pose (:,1),'r');
title ('X-Y');
hold on;
plot (Pose (:,2),'g');

figure
plot (Pose (:,3),'b');
title ('Theta');